<template>
    <div class="page-container">
        <div class="video-button-container">
            <!--            <VideoButton :id="helpModalId">-->
            <!--                <div slot="iframe">-->
            <!--                    <iframe-->
            <!--                        class="embed-responsive-item"-->
            <!--                        src="https://carti.crisp.help/en/article/email-campaigns-1152uka/reader"-->
            <!--                        allowfullscreen-->
            <!--                    />-->
            <!--                </div>-->
            <!--            </VideoButton>-->
        </div>
        <ValidationObserver
            v-if="data"
            ref="obs"
        >
            <div class="edit__top">
                <Tabs
                    ref="tabs"
                    :items="tabs"
                    @switch="tabIndex = $event"
                />
                <Buttons
                    :items="btns"
                    @deleteCampaign="deleteCampaign"
                    @changeStep="changeStep"
                    @openPreviewPopup="openPreviewPopup"
                    @saveDraftTrue="saveDraft(true)"
                    @saveDraftFalse="saveDraft(false)"
                />
                
                <SendTest
                    v-if="previewPopup"
                    ref="test"
                    :input="{placeholder: 'E-mail Address', type: 'data',}"
                    :show-text="showAlertText"
                    @send="sendPreview"
                    @close="previewPopup = false"
                >
                    <template #unsaved>
                        You have unsaved changes. We will send the last saved version of the message.
                    </template>
                </SendTest>
            </div>
            <div
                class="row"
            >
                <component
                    :is="activeTab"
                    :data="data"
                    :second-step="secondStep"
                    :picker-keys="pickerKeys"
                    class="col-12 col-xl-6"
                    @checkChanged="checkChanged"
                />
                <div class="col-12 col-xl-6 edit__preview">
                    <CampaignsEmailExample
                        :data="data"
                    />
                </div>
            </div>
        </ValidationObserver>
    </div>
</template>

<script>
import TextEditorTabCampaigns from "@/components/email/campaigns/TextEditorTabCampaigns";
import DesignEditorTabCampaigns from "@/components/email/campaigns/DesignEditorTabCampaigns";
import CampaignsEmailExample from "@/components/email/campaigns/CampaignsEmailExample";
import campaigns from "@/mixins/email/campaigns.service";
import {tags} from "@/mixins/add-tags"
import SendTest from '@/components/modals/SendTest';
import Tabs from '@/components/elements/Tabs';

export default {
    name: "NewCampaign",
    components: {
         CampaignsEmailExample, DesignEditorTabCampaigns, TextEditorTabCampaigns,
        SendTest, Tabs},
    mixins: [campaigns, tags],
    data() {
        return {
            previewPopup: false,
            emailPreview: '',
            data: null,
            oldData: null,
            edited: null,
            showAlertText: false,
            tabIndex: 0,
            tabs: [
                {title: 'Text editor', component: 'text-editor-tab-campaigns'},
                {title: 'Design editor', component: 'design-editor-tab-campaigns'},
            ],
            pickerKeys: {
                button_color: false,
                button_text: false,
                body_text: false,
                header_background: false,
                header_text: false,
                highlighted_background: false,
                highlighted_text: false,
                link: false,
                title: false,
            },
            secondStep: false,
            helpModalId: 'HelpModalEmailCampaigns',
        }
    },
    computed: {
        activeTab() {
            return this.tabs[this.tabIndex].component
        },
        designComponent() {
            return this.activeTab == 'design-editor-tab-campaigns'
        },
        btns() {
            const btnNext = {title: 'Next', event: 'changeStep', class: 'blue-btn', icon_after: 'fa-angle-right', key: 'next'} 
            const btnBack = {title: 'Back', event: 'changeStep', class: 'blue-btn', icon: 'fa-angle-left', key: 'prev'}

            const element = !this.secondStep ? btnNext : btnBack
            const launch = this.secondStep ? {title: 'Launch', event: 'saveDraftFalse', class: 'blue-btn', icon_after: 'fa-paper-plane'} : null

            const items = [
                {title: 'Cancel', event: 'deleteCampaign', class: 'red-button', icon: 'fa-times'},
                {title: 'Save Drafts', event: 'saveDraftTrue', class: 'light-blue-btn', icon: 'fa-pencil-square-o'},
                {title: 'Send Test', event: 'openPreviewPopup', class: 'light-blue-btn',},
                element,
                launch
            ]

            return items
        },
    },
    created() {
        this.getItems();
    },
    methods: {
        getItems() {
            this.getCampaignsById(this.$route.params.id).then(response => {
                this.data = response.data
                this.data.user_timezone = this.$moment.tz.guess();
                this.data.processed = 0
                
                this.oldData = JSON.parse(JSON.stringify(response.data))
                this.edited = this.createEditedObj(this.oldData)
                if(this.showAlertText) this.showAlertText = false
            }).catch(error => {
                console.log(error)
            });
        },
        async changeStep() {
            const result = await this.$refs.obs.validate();
           let valid = await this.$refs.obs
            if (result) {
                this.secondStep = !this.secondStep
                if(this.secondStep && this.designComponent) this.$refs.tabs.updTab(0)
                setTimeout(() => {
                    this.$refs.obs.reset()
                }, 2000)
            } else this.getFormErrors(valid.errors)
        },
        openPreviewPopup() {
            if(!this.previewPopup) this.showAlertText = this.checkEditedItems(this.edited)
            this.previewPopup = !this.previewPopup
        },
        checkChanged(key) {
            const data = this.trackСhange(this.oldData, this.data, key)

            if(data.key) this.edited[data.key] = data.value
        },
        async saveDraft(data) {

            this.data.is_draft = data
            const result = await this.$refs.obs.validate();
            let valid = await this.$refs.obs
            if (result) {
                const correctData = this.$moment(this.data.schedule_datetime, 'YYYY-MM-DD HH:mm', true).isValid()
                if(!correctData) this.data.schedule_datetime = this.$moment(this.data.schedule_datetime).format('YYYY-MM-DD HH:mm')
              await this.save(this.$route.params.id, this.data)
                    this.$notify({
                        type: 'success',
                        title: 'Saved'
                    });
              if (!this.data.is_draft){
                  await this.$router.push('/email/campaigns/')
              } else this.getItems()
                setTimeout(() => {
                    this.$refs.obs.reset()
                }, 2000)
            } else this.getFormErrors(valid.errors)

        },
        deleteCampaign() {
            if(this.$route.params.first){
                this.delete(this.$route.params.id).then(response => {
                    if (response) {
                        this.$emit('getDrafts')
                        this.$emit('getCampaigns')
                        this.$emit('getHistories')
                        this.$router.push('/email/campaigns/')
                    }
                }).catch(error => {
                    console.log(error)
                });
            } else {
                this.$router.push('/email/campaigns/')
            }
        },
        /**
         *
         * @returns {Promise<void>}
         */
        async sendPreview(email) {
            try {
                await this.sendPreviewEmail(this.$route.params.id, {
                    email,
                })
                this.previewPopup = false
                this.$notify({
                    type: 'success',
                    title: 'Sent'
                })
            }catch (er){
                console.log(er)
                this.$refs.test.stopLoading()

            }
        },
    }
}
</script>

<style scoped lang="scss">

.popup-body-container {
    display: flex;
    justify-content: center;
    align-items: center;
}

.send-action {
    &-container {
        display: flex;
        flex-direction: column;
        width: 100%;
    }
    &__actions {
        margin-top: 1rem;
        display: flex;
        justify-content: flex-end;
        span {
            width: calc(100% - 145px);
            display: block;
            margin-right: auto;opacity: 0.8;
        }
    }

    .blue-btn {
        margin-left: 5px;
        padding: 0pc 20px;
    }
}


.broadcast-form-header {
    margin-top: 40px;
    margin-bottom: 40px;
}

.campaigns-title {
    font-size: 28px;
    font-weight: bold;
    @media screen and (max-width: 765px) {
        margin-bottom: 20px;
    }
}

.light-blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 3px;
    }
}
.red-button {
    @media screen and (max-width: 500px) {
        margin-top: 3px;
    }
}

.blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 3px;
    }
}

</style>
